---
apiVersion: batch/v1
kind: Job
metadata:
  name: rucio-db-backup
  labels:
    tier: data
spec:
  ttlSecondsAfterFinished: 10
  template:
    spec:
      volumes:
      - name: fs-store
        flexVolume:
          driver: ceph.rook.io/rook
          fsType: ceph
          options:
            clusterNamespace: rook
            fsName: nautilusfs
            path: /ligo-rucio
            mountUser: ligo-rucio
            mountSecret: ceph-fs-secret
      - name: postgresqlcert
        secret:
          secretName: pgssl
          items:
          - key: postgresqlcert.pem
            path: postgresqlcert.pem
            mode: 0444
      - name: postgresqlkey
        secret:
          secretName: pgssl
          items:
          - key: postgresqlkey.pem
            path: postgresqlkey.pem
            mode: 0400
      containers:
      - name: postgres
        image: postgres:11
        imagePullPolicy: Always
        command: ["/bin/sh"]
        args: ["-c", "pg_dump -h $(RUCIO_DB_HOST) -U $(POSTGRES_USER) $(POSTGRES_DB) > $(RUCIO_DB_DUMP).`date +%Y-%m-%d-%H-%M`"]
        resources:
          limits:
            cpu: 1
            memory: 8Gi
          requests:
            cpu: 1
            memory: 4Gi
        env:
        - name: RUCIO_DB_HOST
          valueFrom:
            configMapKeyRef:
              name: rucio-db-hostname
              key: RUCIO_DB
        - name: POSTGRES_DB
          value: rucio
        - name: POSTGRES_USER
          value: rucio
        - name: PGPASSWORD
          valueFrom:
            secretKeyRef:
              name: rucio-db
              key: password
        - name: RUCIO_DB_DUMP
          valueFrom:
            configMapKeyRef:
              name: rucio-db-dump
              key: RUCIO_DB_DUMP
        - name: PGSSLCERT
          value: /etc/grid-security/postgresqlcert.pem
        - name: PGSSLKEY
          value: /etc/grid-security/postgresqlkey.pem
        volumeMounts:
        - name: fs-store
          mountPath: /ligo-rucio
        - name: postgresqlcert
          mountPath: /etc/grid-security/postgresqlcert.pem
          subPath: postgresqlcert.pem
        - name: postgresqlkey
          mountPath: /etc/grid-security/postgresqlkey.pem
          subPath: postgresqlkey.pem
      restartPolicy: OnFailure
